# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_control_msgs/ControlSelectionState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_control_msgs.msg

class ControlSelectionState(genpy.Message):
  _md5sum = "0a010322650da6f2a512c9148e878ea9"
  _type = "clearpath_control_msgs/ControlSelectionState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The complete state of the control selection module. This message includes the autonomy state as well as the navigation mode.

ControlState autonomy
ControlMode mode

================================================================================
MSG: clearpath_control_msgs/ControlState
# The autonomy state message, The autonomy can be either enabled/disabled and active/paused.

bool enabled
bool paused

================================================================================
MSG: clearpath_control_msgs/ControlMode
# Control mode message

int8 NEUTRAL=0
int8 MANUAL=1
int8 AUTONOMY=2

int8 mode
"""
  __slots__ = ['autonomy','mode']
  _slot_types = ['clearpath_control_msgs/ControlState','clearpath_control_msgs/ControlMode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       autonomy,mode

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ControlSelectionState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.autonomy is None:
        self.autonomy = clearpath_control_msgs.msg.ControlState()
      if self.mode is None:
        self.mode = clearpath_control_msgs.msg.ControlMode()
    else:
      self.autonomy = clearpath_control_msgs.msg.ControlState()
      self.mode = clearpath_control_msgs.msg.ControlMode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2Bb().pack(_x.autonomy.enabled, _x.autonomy.paused, _x.mode.mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.autonomy is None:
        self.autonomy = clearpath_control_msgs.msg.ControlState()
      if self.mode is None:
        self.mode = clearpath_control_msgs.msg.ControlMode()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.autonomy.enabled, _x.autonomy.paused, _x.mode.mode,) = _get_struct_2Bb().unpack(str[start:end])
      self.autonomy.enabled = bool(self.autonomy.enabled)
      self.autonomy.paused = bool(self.autonomy.paused)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2Bb().pack(_x.autonomy.enabled, _x.autonomy.paused, _x.mode.mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.autonomy is None:
        self.autonomy = clearpath_control_msgs.msg.ControlState()
      if self.mode is None:
        self.mode = clearpath_control_msgs.msg.ControlMode()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.autonomy.enabled, _x.autonomy.paused, _x.mode.mode,) = _get_struct_2Bb().unpack(str[start:end])
      self.autonomy.enabled = bool(self.autonomy.enabled)
      self.autonomy.paused = bool(self.autonomy.paused)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Bb = None
def _get_struct_2Bb():
    global _struct_2Bb
    if _struct_2Bb is None:
        _struct_2Bb = struct.Struct("<2Bb")
    return _struct_2Bb
