// Auto-generated. Do not edit!

// (in-package clearpath_control_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ControlState = require('./ControlState.js');
let ControlMode = require('./ControlMode.js');

//-----------------------------------------------------------

class ControlSelectionState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.autonomy = null;
      this.mode = null;
    }
    else {
      if (initObj.hasOwnProperty('autonomy')) {
        this.autonomy = initObj.autonomy
      }
      else {
        this.autonomy = new ControlState();
      }
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = new ControlMode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ControlSelectionState
    // Serialize message field [autonomy]
    bufferOffset = ControlState.serialize(obj.autonomy, buffer, bufferOffset);
    // Serialize message field [mode]
    bufferOffset = ControlMode.serialize(obj.mode, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ControlSelectionState
    let len;
    let data = new ControlSelectionState(null);
    // Deserialize message field [autonomy]
    data.autonomy = ControlState.deserialize(buffer, bufferOffset);
    // Deserialize message field [mode]
    data.mode = ControlMode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_control_msgs/ControlSelectionState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0a010322650da6f2a512c9148e878ea9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The complete state of the control selection module. This message includes the autonomy state as well as the navigation mode.
    
    ControlState autonomy
    ControlMode mode
    
    ================================================================================
    MSG: clearpath_control_msgs/ControlState
    # The autonomy state message, The autonomy can be either enabled/disabled and active/paused.
    
    bool enabled
    bool paused
    
    ================================================================================
    MSG: clearpath_control_msgs/ControlMode
    # Control mode message
    
    int8 NEUTRAL=0
    int8 MANUAL=1
    int8 AUTONOMY=2
    
    int8 mode
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ControlSelectionState(null);
    if (msg.autonomy !== undefined) {
      resolved.autonomy = ControlState.Resolve(msg.autonomy)
    }
    else {
      resolved.autonomy = new ControlState()
    }

    if (msg.mode !== undefined) {
      resolved.mode = ControlMode.Resolve(msg.mode)
    }
    else {
      resolved.mode = new ControlMode()
    }

    return resolved;
    }
};

module.exports = ControlSelectionState;
